unit gamecreationstatusunit;

interface

uses
  Classes, SysUtils, mainunit, sdl, guiunit,orthounit, guidrawerunit, 
  openglUnit, globalunit, stateunit, gl, glu, guiextraunit, messageunit;


type TGameCreationStatus=class(TEventListener)
 private
  Desktop:TUiDesktop;
  GuiDrawer:TGuiDrawer;
 public
  Constructor Create;
  Destructor destroy; override;

  procedure InitGui;

  procedure onGameStartButtonClick(sender:TUiWidget);
  procedure onGameExitButtonClick(sender:TUiWidget);
 
  procedure Enter; override;
  procedure Exit; override;
  procedure DoLoop; override;
  procedure KeyDownEvent(key:TSDL_KeyboardEvent);override;
  procedure KeyUpEvent(key:TSDL_KeyboardEvent);override;
  procedure MouseDownEvent(event:TSDL_MouseButtonEvent);override;
  procedure MouseUpEvent(event:TSDL_MouseButtonEvent);override;
  procedure MouseMoveEvent(event:TSDL_MouseMotionEvent);override;
end;

var GameCreationStatus:TGameCreationStatus;

implementation

uses chatstatusunit, gamestatusunit;

procedure TGameCreationStatus.onGameStartButtonClick(sender:TUiWidget);
begin
ChangeListener(GameStatus);
end;

procedure TGameCreationStatus.onGameExitButtonClick(sender:TUiWidget);
begin
ChangeListener(ChatStatus);
end;

Constructor TGameCreationStatus.Create;
begin
InitGui;
GuiDrawer:=TGuiDrawer.Create(global.man);
end;

Destructor TGameCreationStatus.destroy;
begin
Desktop.Free;
GuiDrawer.Free;
end;


procedure TGameCreationStatus.initGui;
var l:TUiLabel;
    button:TUiButton;
    Window:TUiWindow;
    i:TUiImage;
begin

  desktop:=TUiDesktop.create;

  LoadGui(desktop, 'media/gamecreation.ui');
  
  TUiButton(Desktop.WidgetByName('GameStartButton')).onClick:=onGameStartButtonClick;
  TUiButton(Desktop.WidgetByName('GameExitButton')).onClick:=onGameExitButtonClick;


end;




procedure TGameCreationStatus.Enter;
begin
Desktop.ResetFocus;
end;

procedure TGameCreationStatus.Exit;
begin
end;

procedure TGameCreationStatus.DoLoop;
begin
 // if global.conn.DataAvaiable then readMessage;


  // clear z and color
  glClear( GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT );


  // start calculation of the matrix (by loading identity)
  glLoadIdentity;
  gluLookAt(20,20,20,0,0,0,0,1,0);

(*  // draw something to show gui integration with scene rendering
  drawOriginLines(10);
  glColor3f(1,1,1);
//  glRotatef(rot, 0, 1, 0);
  global.man.getTextureByName('car0').bind;
  global.man.getMeshByName('chassis').draw;
*)

  // switch to ortho projection
  BeginOrtho(SCREEN_WIDTH, SCREEN_HEIGHT);


  global.man.getTextureByName('background').bind;
  DrawRectangle(0,0,SCREEN_WIDTH, SCREEN_HEIGHT, 1,1,1);
  // draw the gui
  GuiDrawer.draw(Desktop);
  // draw the mouse pointer
  global.man.getTextureByName('pointer').bind;
  DrawRectangle(global.mx,global.my,64,64, 1, 1, 1);

  // go back to normal projection
  EndOrtho;

  // finally, show our nice frame!
  SDL_GL_SwapBuffers;


end;

procedure TGameCreationStatus.MouseDownEvent(event:TSDL_MouseButtonEvent);
begin
 desktop.DoMouseDown(event.x,event.y, TMouseButton(event.button));
end;

procedure TGameCreationStatus.MouseUpEvent(event:TSDL_MouseButtonEvent);
begin
 desktop.DoMouseUp(event.x,event.y, TMouseButton(event.button));
end;

procedure TGameCreationStatus.MouseMoveEvent(event:TSDL_MouseMotionEvent);
begin
 desktop.DoMouseMove(event.x,event.y);
 global.mx:=event.x;
 global.my:=event.y;
end;

procedure TGameCreationStatus.KeyDownEvent(key:TSDL_KeyboardEvent);
begin
 Desktop.DoKeyPress(char(key.keysym.unicode and $FF));
 global.keystate.processKeyDown(key.keysym.sym);
 if key.keysym.sym = SDLK_ESCAPE then global.loop.StopLoop;
end;

procedure TGameCreationStatus.KeyUpEvent(key:TSDL_KeyboardEvent);
begin
 global.keystate.processKeyUp(key.keysym.sym);
end;



end.

