unit loginstatusunit;

interface

uses
  Classes, SysUtils, mainunit, sdl, guiunit,orthounit, guidrawerunit, 
  openglUnit, globalunit, stateunit, gl, glu, guiextraunit, messageunit;


type TLoginStatus=class(TEventListener)
 public
  Desktop:TUiDesktop;
  ServerEdit, UserEdit, PassEdit:TUiEdit;
  GuiDrawer:TGuiDrawer;

  Constructor Create;
  Destructor destroy; override;

  procedure InitGui;
 
  procedure onOkClick(sender:TUiWidget);
  procedure onExitClick(sender:TUiWidget);
  
  procedure Enter; override;
  procedure Exit; override;
  procedure DoLoop; override;
  procedure KeyDownEvent(key:TSDL_KeyboardEvent);override;
  procedure KeyUpEvent(key:TSDL_KeyboardEvent);override;
  procedure MouseDownEvent(event:TSDL_MouseButtonEvent);override;
  procedure MouseUpEvent(event:TSDL_MouseButtonEvent);override;
  procedure MouseMoveEvent(event:TSDL_MouseMotionEvent);override;
end;

var LoginStatus:TLoginStatus;

implementation

uses chatstatusunit, gamecreationstatusunit, messageparserunit;


Constructor TLoginStatus.Create;
begin
InitGui;
GuiDrawer:=TGuiDrawer.Create(global.man);
end;

Destructor TLoginStatus.destroy;
begin
Desktop.Free;
GuiDrawer.Free;
end;

(*
procedure TLoginStatus.readMessage;
var s:string;
    m:TMsg;
begin
if not global.conn.Recv(s) then exit; // @todo handle disconnections here
writeln('received ',s);
if s='' then exit;
m:=TMsg.create(s);
case m.getType of
 M_LOGIN_OK:
   begin
     // @todo initialize this user
     ChatStatus.UserList.Strings.Clear;
     ChatStatus.UserList.Strings.Add(m[1]);
     
     ChangeListener(ChatStatus);
   end;
 M_LOGIN_NO:
   begin
     global.conn.close;
     Desktop.AddModal(TUiErrorWindow.Create('Access denied: '+m[1]));
   end;
 else
   writeln('Unexpected message '+s);
end;

m.free;


end;
*)


procedure TLoginStatus.onOkClick(sender:TUiWidget);
begin
 if global.conn.Connect(ServerEdit.Text, 50401) then
   begin
     global.conn.Send(msg(M_LOGIN, [UserEdit.Text, PassEdit.Text]));
     passEdit.Text:='';
   end
 else
  begin
   Desktop.AddModal(TUiErrorWindow.Create('Could not connect to server.'));
  end;
end;

procedure TLoginStatus.onExitClick(sender:TUiWidget);
begin
 global.Loop.StopLoop;
 // ChangeListener(GameCreationStatus);
end;

procedure TLoginStatus.initGui;
var l:TUiLabel;
    button:TUiButton;
    Window:TUiWindow;
    i:TUiImage;
begin

	desktop:=TUiDesktop.create;

(*  i:=TUiImage.create;
  i.left:=30;
  i.top:=30;
  i.image:=global.man.getTextureByName('minicup').texture;
  desktop.add(i);*)
 
 // LoadGui(desktop, 'media/chat.ui'); 
 
  LoadGui(desktop, 'media/login.ui');
  
  ServerEdit:=TUiEdit( desktop.WidgetByName('ServerEdit') );
  UserEdit:=TUiEdit( desktop.WidgetByName('UserEdit') );
  PassEdit:=TUiEdit( desktop.WidgetByName('PassEdit') );
  
  TUiButton( desktop.WidgetByName('OkButton') ).OnClick := OnOkClick;
  TUiButton( desktop.WidgetByName('ExitButton') ).OnClick := OnExitClick;
  
end;




procedure TLoginStatus.Enter;
begin
if global.conn.Connected then
begin
 global.conn.Send(msg(M_QUIT, []));
 global.conn.Close;
 
end;
Desktop.ResetFocus;
end;

procedure TLoginStatus.Exit;
begin
end;

procedure TLoginStatus.DoLoop;
begin
  if global.conn.DataAvaiable then parseMessage;


  // clear z and color
  glClear( GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT );


  // start calculation of the matrix (by loading identity)
  glLoadIdentity;
  gluLookAt(5,5,5,0,0,0,0,1,0);

(*  // draw something to show gui integration with scene rendering
  drawOriginLines(10);
*)
  glColor3f(1,1,1);
  //glRotatef(random(1000), 0, 1, 0);
//  global.man.getTextureByName('car0').bind;
//  global.man.getMeshByName('chassis').draw;

  // switch to ortho projection
  BeginOrtho(SCREEN_WIDTH, SCREEN_HEIGHT);

  global.man.getTextureByName('background').bind;
  DrawRectangle(0,0,SCREEN_WIDTH, SCREEN_HEIGHT, 1,1,1);
  // draw the gui
  GuiDrawer.draw(Desktop);
  // draw the mouse pointer
  global.man.getTextureByName('pointer').bind;
  DrawRectangle(global.mx,global.my,64,64, 1, 1, 1);

  // go back to normal projection
  EndOrtho;

  // finally, show our nice frame!
  SDL_GL_SwapBuffers;


end;

procedure TLoginStatus.MouseDownEvent(event:TSDL_MouseButtonEvent);
begin
 desktop.DoMouseDown(event.x,event.y, TMouseButton(event.button));
end;

procedure TLoginStatus.MouseUpEvent(event:TSDL_MouseButtonEvent);
begin
 desktop.DoMouseUp(event.x,event.y, TMouseButton(event.button));
end;

procedure TLoginStatus.MouseMoveEvent(event:TSDL_MouseMotionEvent);
begin
 desktop.DoMouseMove(event.x,event.y);
 global.mx:=event.x;
 global.my:=event.y;
end;

procedure TLoginStatus.KeyDownEvent(key:TSDL_KeyboardEvent);
begin
 Desktop.DoKeyPress(char(key.keysym.unicode and $FF));
 global.keystate.processKeyDown(key.keysym.sym);
 if key.keysym.sym = SDLK_ESCAPE then global.loop.StopLoop;
end;

procedure TLoginStatus.KeyUpEvent(key:TSDL_KeyboardEvent);
begin
 global.keystate.processKeyUp(key.keysym.sym);
end;



end.

