unit clientunit;

interface

uses
  Classes, SysUtils, networkunit;

type

  TConnection = class
    private
      fSocket:TSocket;
      fSet:TSocketSet;
    public
      function Connect(const host:string; port:word):boolean;
      function DataAvaiable:boolean;
      function Recv(out s:string):boolean;
      procedure Send(const s:string);
      constructor Create;
      procedure Close;
      destructor Destroy;override;
      function Connected:boolean;
  end;


implementation

function TConnection.Connected:boolean;
begin
Result:=fSocket.active;
end;

procedure TConnection.Close;
begin
if fSocket.Active then fsocket.close;
fSet.Remove(fsocket);
end;

function TConnection.Connect(const host:string; port:word):boolean;
begin
result:=fSocket.Connect(host, port);
if result then result:=fSet.Add(fsocket);
end;

function TConnection.DataAvaiable:boolean;
begin
 result:=fSet.Activity(false);
end;

constructor TConnection.Create;
begin
fSocket:=TSocket.create;
fSet:=TSocketSet.create(1);
end;

destructor TConnection.Destroy;
begin
fSocket.free;
fSet.free;
end;

function TConnection.Recv(out s:string):boolean;
begin
result:=fSocket.Recv(s);
end;

procedure TConnection.Send(const s:string);
begin
fSocket.Send(s);
end;

end.

