unit glmapunit;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, mapunit, gl, glu, sdl, openglunit;


const TILE_SIZE = 4;

type

TGlMap = class(TMap)
private
  private
    list:cardinal;
    procedure BuildDisplayList;
    procedure FreeDisplayList;
    procedure DrawComplete;
  public
    constructor Create;override;
    procedure Render; override;
    destructor Destroy; override;
end;


implementation

procedure Rectangle(x,z,w,h:single);
begin
  glBegin( GL_TRIANGLE_STRIP  );         // Drawing Using Triangles

    glTexCoord2f(0,0);
    glVertex3f(  x, 0,  z );

    glTexCoord2f(0,1);
    glVertex3f(  x,0,  z+H );

    glTexCoord2f(1,0);
    glVertex3f(  x+W,0,  z );

    glTexCoord2f(1,1);
    glVertex3f(  x+W,0,  z+H );
  glEnd;                            // Finished Drawing The Triangle
end;



constructor TGlMap.Create;
begin
  inherited Create;
  list:=0;
end;

procedure TGlMap.Render;
begin
if list=0 then BuildDisplayList; // display list on the fly :P
glCallList(list);
end;

(*
  This draws the mesh directly without using display lists
 *)
procedure TGlMap.DrawComplete;
var x,y:integer;
begin

 glBegin(GL_TRIANGLES);
 SetMaterialColor(1,1,1);
   for x:=0 to sizex-1 do
     for y:=0 to sizey-1 do
       Rectangle(x*TILE_SIZE,y*TILE_SIZE, TILE_SIZE,TILE_SIZE);
 glEnd();
end;


procedure TGlMap.BuildDisplayList;
begin
if list<>0 then exit;        // already created!
list:=glGenLists(1);         // obtain a new list
glNewList(list,GL_COMPILE);  // start drawing it!
DrawComplete;                // draw it!
glEndList;                   // finished drawing
end;


procedure TGlMap.FreeDisplayList;
begin
if list=0 then exit;      // no list created
glDeleteLists(list, 1);
list:=0;
end;

destructor TGlMap.Destroy;
begin
	freedisplaylist;
	inherited Destroy;
end;



end.

