unit mainunit;

(*

This unit was written by Nicola {MSX} Lugato.

http://msx.rules.it
nicola@lugato.net
nicola.lugato@gmail.com

It is released under the term of
The GNU General Public License as published by the Free
Software Foundation.

This program is dedicated to Fabiana

Description:

This is the main file of the game.
The TProg class represent the program.

*)

interface


uses
  openglmainloop, screenunit, openglunit, meshunit,
  SDL, GLU, GL, mediamanagerunit,guidrawerunit,
  types3d, SysUtils, guiunit,clientunit,
  glmeshunit, orthounit, globalunit, messageparserunit,
  frustumunit, math, msxmath,
  keyboardunit;

type

// this class simply represent the program
TProg = class
  procedure initGl;
  procedure Start;
  procedure Cleanup;
end;



implementation

uses loginstatusunit, stateunit, chatstatusunit, gamecreationstatusunit,gamestatusunit;

var rot:TFloat =0;



procedure TProg.initGl;
begin
	// opengl initialization
  glMatrixMode(GL_MODELVIEW);
  glEnable(gl_Blend);
  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
  glDisable(GL_LIGHTING);
  glClearColor(0,0,0,0);
  
 SDL_EnableKeyRepeat(SDL_DEFAULT_REPEAT_DELAY,SDL_DEFAULT_REPEAT_INTERVAL);
 SDL_EnableUnicode(1);

 glEnable(GL_TEXTURE_2D);

 // glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
 glEnable(GL_CULL_FACE);
 glCullFace(GL_Back);
 
 glLightfv(GL_LIGHT1, GL_AMBIENT, @LightAmbient);
 glLightfv(GL_LIGHT1, GL_DIFFUSE, @LightDiffuse);
 glLightfv(GL_LIGHT1, GL_POSITION, @LightPosition);
 glEnable(GL_LIGHT1);

end;


procedure TProg.Cleanup;
begin
	Global.screen.finalize;
end;

procedure TProg.Start;
//var login:TLoginStatus;
begin
// StateManager:=TStateManager.Create;
 
 Global.screen:=TScreen.Create('Turn based game by {MSX}!', 800, 600, 16, ParamStr(1)='-fs', 500);
 if not Global.screen.Initialize then exit;
 
 // keyboard state helper
 Global.keystate:=tkeystate.create;

 // start up our kind media manager
 Global.man:=TFileMediaManager.Create;

 // set up the main loop
 global.Loop:=TOpenGlRealTimeLoop.create;


 global.conn:=TConnection.create;
 // initialize some other things
 initGl;

// StateManager.ChangeState(TLoginStatus);

 LoginStatus:=TLoginStatus.create;
 ChatStatus:=TChatStatus.create;
 GameCreationStatus:=TGameCreationStatus.create;
 gamestatus:=TGameStatus.create;
 
 ChangeListener(LoginStatus);

 // ready to go! :P
 global.loop.StartLoop;

end;

end.
