unit messageparserunit;

interface

uses
  Classes, SysUtils;

procedure parseMessage;

implementation

uses MessageUnit, GlobalUnit, LoginStatusUnit, GameCreationStatusUnit, StateUnit, ChatStatusUnit, guiunit, guiextraunit;

function parseLogin(m:TMsg):boolean;
begin
result:=true;
case m.getType of
 M_LOGIN_OK:
   begin
     // @todo initialize this user
     ChatStatus.UserList.Strings.Clear;
     ChatStatus.UserList.Strings.Add(m[1]);
     global.username:=m[1];
     ChangeListener(ChatStatus);
   end;
 M_LOGIN_NO:
   begin
     global.conn.close;
     LoginStatus.Desktop.AddModal(TUiErrorWindow.Create('Access denied: '+m[1]));
   end;
 else
   begin
     writeln('Unexpected message');
     result:=falsE;
   end;
end;

end;

function parse(m:TMsg):boolean;
var i:integer;
begin
result:=true;
case m.getType of
 M_ENTER:
   begin
     ChatStatus.AddChatList(m[1]+' entered.');
     ChatStatus.UserList.Strings.Add(m[1]);
   end;
 M_CHAT:
   begin
     ChatStatus.AddChatList('<'+m[1]+'> '+m[2]);
   end;
 M_USERLIST:
   begin
     ChatStatus.UserList.Strings.Add(m[1]);
   end;
 M_CREATE_GAME:
   begin
     // 'G|101|New Game|ClassicMap|1000|msx'
     ChatStatus.addGame(m[1], m[2], m[3], m[4], m[5]);
   end;
 M_ENTER_GAME:
   begin
   	// we should enter given game!

   end;
 M_EXIT:
   begin
     ChatStatus.AddChatList(m[1]+' exited.');
     i:=ChatStatus.UserList.Strings.IndexOf(m[1]);
     if i>=0 then ChatStatus.UserList.Strings.Delete(i);
   end;
 else
   begin
   	 // set up as false, maybe later setted to true by state-specific parser
     result:=falsE;
     if LoginStatus.active then result:=parseLogin(m);
   end;
end;

end;

procedure parseMessage;
var s:string;
    m:TMsg;
begin
if not global.conn.Recv(s) then exit; // @todo handle disconnections here
writeln('received ',s);
if s='' then exit;
m:=TMsg.create(s);
parse(m);
m.free;


end;



end.

