unit game; 

interface

uses
  Classes, SysUtils, baseunit, commonunit;

Type

 {** A base class for units and items }
 TElement = class
 end;

 {** A player currently involved in the game }
 TPlayer = class
 end;

 TPlayerList = class(TList)
 end;

 
 {** An item of the game.
 This contains the model plus all runtime data needed
 for the game }
 TItem = class(TElement)
   info:TItemStaticInfo;
   posX, posY:integer;
 end;


 TItemList = class(TList)
 end;

 {** A unit of the game.
 This contains the model plus all runtime data needed
 for the game }
 TUnit = class(TElement)
   info:TUnitStaticInfo;

   owner:TPlayer;
   actionPoint:integer;
   lifePoint:integer;
   posX, posY:integer;
 end;


 TUnitList = class(TList)
 end;

 {** The data regarding the map
 mainly this will be a tile matrix }
 TMap = class
   sizeX, sizeY:integer;
 end;
 
 {** This is an instance of a running game }
 TGame = class
   Players:TPlayerList;
   Map:TMap;
   Turns:integer;
   Items:TItemList;
   Units:TUnitList;
 end;
 
 TGameList = class(TList)
 end;
 

implementation

end.

