unit messageunit;

interface

uses SysUtils, Classes;

 const
  M_CHAT = 'C';
  M_ENTER = 'E';
  M_ENTER_GAME = 'F';
  M_CREATE_GAME = 'G';
  M_REMOVE_GAME = 'H';
  M_LOGIN = 'L';
  M_LOGIN_NO = 'N';
  M_LOGIN_OK = 'O';
  M_QUIT = 'Q';
  M_REGISTER = 'R';
  M_REGISTER_OK = 'S';
  M_REGISTER_NO = 'T';
  M_USERLIST = 'U';
  M_EXIT = 'X';
  M_EXIT_GAME = 'Y';


Type
TSArray = array of string;

TMsg = class
private
 sarr:TSArray;
 function getToken(index:integer):string;
public
 function getType:char;
 function numParam:integer;
 constructor Create(message:string);
 destructor destroy; override;
 property Token[index:integer]:string read getToken; default;
end;

{** This function generate a string to be sent to server. The string will be in the form:
MType +'|'+ param1 + '|' +param2 +'|'+ ...
Eventual '|' char present on the string will be escaped to &pipe; }
function msg(MType:char; params:array of string):string;



implementation

function msg(MType:char; params:array of string):string;
var i,l:integer;
    parstr:string;
begin
parstr:='';
l:=length(params)-1;
for i:=0 to l do
 begin
  // remove '|' from input params, replacing it with an escape sequence
  parstr:=parstr+StringReplace(params[i],'|','&pipe;',[rfReplaceAll]);
  if i<l then parstr:=parstr+'|';
 end;

result:=mType+'|'+parstr;
end;


function SeparateString(s:string;separator:char):TSArray;
var i:integer;
    c:char;
    word:string;
begin
SetLength(result,0);
i:=1; word:='';
while i<=length(s) do
 begin
  c:=s[i];
  if c=separator then
   begin
    setlength(result, length(result)+1);
    result[length(result)-1]:=word;
    word:='';
    // ora scorriamo il resto di separator
    inc(i);
    while (s[i] = separator) and (i<=length(s)) do
     inc(i);
   end
  else
   begin
    word:=word+c;
    inc(i);
   end;
 end;
if word<>'' then
 begin
  setlength(result, length(result)+1);
  result[length(result)-1]:=word;
 end;
end;

constructor TMsg.Create(message:string);
var i:integer;
begin
 if message = '' then
   begin
     setLength(sarr,1);
     sarr[0]:='-';
   end
  else
    begin
      sarr:=separateString(message,'|');
    end;
end;

destructor TMsg.destroy;
begin
 setlength(sarr,0);
 inherited destroy;
end;

function TMsg.getToken(index:integer):string;
begin
result:=sarr[index];
end;
function TMsg.getType:char;
begin
result:=(sarr[0])[1];
end;
function TMsg.numParam:integer;
begin
result:=length(sarr)-1;
end;

end.
