{** Utility class for handling keyboard.. to be expanded}
unit keyboardunit; 

interface

uses
  Classes, SysUtils, SDL; 

Type
 TKeyState = class
   left, shift, right, up, down, tab, ctrl:boolean;    // key being pressed
   procedure processKeyUp(SDL_Key:word);
   procedure processKeyDown(SDL_Key:word);
 end;

implementation

procedure TKeyState.processKeyUp(SDL_Key:word);
begin
case SDL_Key of
  SDLK_RIGHT: right := false;
  SDLK_LEFT: left := false;
  SDLK_UP: up:=false;
  SDLK_TAB: tab:=false;
  SDLK_RCTRL, 
  SDLK_LCTRL: ctrl:=false;
  SDLK_DOWN: down:=false;
  SDLK_RSHIFT,
  SDLK_LSHIFT: shift:=false;
end;
end;

procedure TKeyState.processKeyDown(SDL_Key:word);
begin
case SDL_Key of
  SDLK_RIGHT: right := true;
  SDLK_LEFT: left := true;
  SDLK_UP: up:=true;
  SDLK_TAB: tab:=true;
  SDLK_RCTRL, 
  SDLK_LCTRL: ctrl:=true;
  SDLK_DOWN: down:=true;
  SDLK_RSHIFT,
  SDLK_LSHIFT: shift:=true;
end;
end;


end.

