unit orthounit;

interface

uses gl,glu;

procedure BeginOrtho(Width, Height:Single);
procedure EndOrtho;

implementation

procedure BeginOrtho(Width, Height:Single);
begin
	 // no z buffer
   glDisable(GL_DEPTH_TEST);   
   // go to matrix proj
   glMatrixMode(GL_PROJECTION);
   // store it
   glPushMatrix;
   // reset and...
   glLoadIdentity();
   // ...set our ortho
   glOrtho(0, Width, Height, 0, 0, 100);
   // return to modelview, and reset it
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();
end;

procedure EndOrtho;
begin
	// restart z buffer testing
  glEnable(GL_DEPTH_TEST);
  // return to projection
  glMatrixMode(GL_PROJECTION);
  // restore projection
  glPopMatrix;
  // return to modelview
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
end;



end.