unit stateunit;

interface

uses Classes, SysUtils, openglmainloop, sdl;

type

TEventListener = class
  active:boolean;
  procedure Enter; virtual; abstract;
  procedure Exit; virtual; abstract;
  procedure DoLoop; virtual; abstract;
  procedure KeyDownEvent(key:TSDL_KeyboardEvent); virtual; abstract;
  procedure KeyUpEvent(key:TSDL_KeyboardEvent); virtual; abstract;
  procedure MouseDownEvent(event:TSDL_MouseButtonEvent); virtual; abstract;
  procedure MouseUpEvent(event:TSDL_MouseButtonEvent); virtual; abstract;
  procedure MouseMoveEvent(event:TSDL_MouseMotionEvent); virtual; abstract;
  
  procedure ConnectLoop(l:TOpenGlGenericLoop);
  

end;

var ActiveEvent:TEventListener = nil;


procedure ChangeListener(new:TEventListener);


//TStateClass = class of TStatus;
(*
TStateManager = class
 private
  fStatus:TStatus;
 public
  destructor Destroy;override;
  constructor Create;
  function CurrentState:TStatus;
  procedure ChangeState(StateClass:TStateClass);
end;

var StateManager:TStateManager;
*)
implementation

uses Globalunit;

procedure ChangeListener(new:TEventListener);
begin
 if ActiveEvent <> nil then 
  begin
  	ActiveEvent.Exit;
  	ActiveEvent.active:=false;
  end;
 new.active:=true;  
 ActiveEvent:=new;
 new.Enter;
 new.ConnectLoop(global.loop);
end;

(*
constructor TStateManager.Create;
begin
	fStatus:=nil;

end;

destructor TStateManager.Destroy;
begin
	if fStatus<>nil then
	  begin
	  	fStatus.exit;
	  	fStatus.free;
	  end;
	inherited Destroy;
end;

function TStateManager.CurrentState:TStatus;
begin
	result:=fStatus;
end;

procedure TStateManager.ChangeState(StateClass:TStateClass);
begin
	if fStatus<>nil then
	  begin
	  	fStatus.exit;
	  	fStatus.free;
	  end;
	fStatus:=TStatus(StateClass.newInstance );
  fStatus.ConnectLoop(global.loop);
	fStatus.enter;
end;
                                  *)
procedure TEventListener.ConnectLoop(l:TOpenGlGenericLoop);
begin
 l.setCycleEvent(DoLoop);
 l.setMouseDownEvent(MouseDownEvent);
 l.setMouseUpEvent(MouseUpEvent);
 l.setMouseMoveEvent(MouseMoveEvent);
 l.setKeyDownEvent(KeyDownEvent);
 l.setKeyUpEvent(KeyUpEvent);
end;

end.
