{** This unit defines some useful types and constants to be used with 3d programs. *}
unit types3d;


(*

This unit was written by Nicola {MSX} Lugato.

http://msx.rules.it
nicola@lugato.net
nicola.lugato@gmail.com

It is released under the term of
The GNU General Public License as published by the Free
Software Foundation.

*)


interface

const epsilon = 0.00000000001; // very small number :P

type TFloat = single;  // centralized choice of floating point type

type
  TVertex = record
      x: TFloat;             // Homogeneous coordinates
      y: TFloat;
      z: TFloat;
      nx: TFloat;            // Normal
      ny: TFloat;
      nz: TFloat;
      tu: TFloat;            // Texture coordinates
      tv: TFloat;
  end;

  Tuv=record
    u,v:TFloat;
  end;

    TFace = record
                  point:array[1..3] of integer; // three vertex to connect
                  nx,ny,nz:TFloat;              // face normal
                  uv:array[1..3] of TUV;            // face uv map
                  smooth:boolean;                      // tells if the face is smooth shaded
    end;

(*
    // classic 3 value vector
    TVector=record
         case integer of
          0: (v:array[0..2] of TFloat);
          1: (x, y, z: TFloat);
        end;
*)

type TRGB = array [0..2] of TFloat;


implementation

procedure dummy;
begin
end;

end.
