unit socketutils;

interface

uses
{$IFDEF MSWINDOWS}
  Windows, WinSock,
{$ENDIF}
{$IFDEF LINUX}
  Libc,
{$ENDIF}

  Classes, SysUtils; 


function GetIPFormTsockaddr(s:Tsockaddr):string;
procedure SocketClose(s:TSocket);
procedure SendString(socket:TSocket; s:String);
function ReceiveString(Socket:TSocket; var s:string):boolean;

implementation

procedure SocketClose(s:TSocket);
begin
   {$IFDEF MSWINDOWS}
    closesocket(s);
   {$ENDIF}
   {$IFDEF LINUX}
   write('close socket linux: ');
   writeln(Shutdown(s,2));
   {$ENDIF}
end;


// ottiene l'ip dal TSockAddr
function GetIPFormTsockaddr(s:Tsockaddr):string;
begin
result:=
inttostr(ord(s.sin_addr.S_un_b.s_b1))+'.'+
inttostr(ord(s.sin_addr.S_un_b.s_b2))+'.'+
inttostr(ord(s.sin_addr.S_un_b.s_b3))+'.'+
inttostr(ord(s.sin_addr.S_un_b.s_b4));
end;

function ReceiveString(Socket:TSocket;var s:string):boolean;
var c:char;
    ancora:boolean;
    r:integer;
begin
ancora:=true; result:=true; s:='';
while ancora do
 begin
  r:=recv(socket,@c,1,0);
  if r=0 then
   begin
     result:=false;
     exit;
   end;
  if r=socket_ERROR then
   begin
    result:=false; s:='';
    exit;
   end;

  if c=#13 then
   begin
    exit;
   end;

  s:=s+c;
  
  if length(s)>2000 then
    begin
      result:=false;
      exit;
    end;
  end;

end;



procedure SendString(socket:TSocket; s:String);
begin
   {$IFDEF MSWINDOWS}
    send(socket,s[1],length(s),0);
   {$ENDIF}
   {$IFDEF LINUX}
    send(socket,@s[1],length(s),MSG_NOSIGNAL);
   {$ENDIF}
end;


end.

